// H323.cpp : Implementation of CH323

#include "stdafx.h"
#include "Atlh323.h"
#include "vbH323.h"


short SType(BSTR *pbstr);

/////////////////////////////////////////////////////////////////////////////
// CH323


STDMETHODIMP CH323::get_FastStart(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here
	*pVal = !(endpoint->noFastStart);
	return S_OK;
}

STDMETHODIMP CH323::put_FastStart(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here
	endpoint->noFastStart = !(newVal);
	return S_OK;
}

STDMETHODIMP CH323::get_JitterDelay(short *pVal)
{
	// TODO: Add your implementation code here
	*pVal = (short) endpoint->GetMaxAudioDelayJitter();
	return S_OK;
}

STDMETHODIMP CH323::put_JitterDelay(short newVal)
{
	// TODO: Add your implementation code here
	endpoint->SetMaxAudioDelayJitter((unsigned) newVal);
	return S_OK;
}


STDMETHODIMP CH323::get_UserName(BSTR *pVal)
{
	// TODO: Add your implementation code here
	*pVal = A2BSTR(endpoint->GetLocalUserName());
	return S_OK;
}

STDMETHODIMP CH323::put_UserName(BSTR newVal)
{
	// TODO: Add your implementation code here
	if (SType(&newVal) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("Username string is empty or NULL"));
	else
		endpoint->SetLocalUserName(newVal);
	return S_OK;
}

STDMETHODIMP CH323::get_RemoteHost(BSTR *pVal)
{
	// TODO: Add your implementation code here
	if (SType(&Destination) < 4)  // check we have a valid string from VB
		*pVal = A2BSTR("");
	else
		*pVal = Destination;
	return S_OK;
}

STDMETHODIMP CH323::put_RemoteHost(BSTR newVal)
{
	// TODO: Add your implementation code here
	if (SType(&newVal) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("Destination string is empty or NULL"));
	else
		Destination = newVal;
	return S_OK;
}

STDMETHODIMP CH323::get_GateKeeper(BSTR *pVal)
{
	// TODO: Add your implementation code here
	if (SType(&GateKeeper) < 4)  // check we have a valid string from VB
		*pVal = A2BSTR("");
	else
		*pVal = GateKeeper;
	return S_OK;
}

STDMETHODIMP CH323::put_GateKeeper(BSTR newVal)
{
	// TODO: Add your implementation code here
	if (SType(&newVal) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("Gatekeeper string is empty or NULL"));
	else
		GateKeeper = newVal;
	return S_OK;
}

STDMETHODIMP CH323::get_Gateway(BSTR *pVal)
{
	// TODO: Add your implementation code here
	if (SType(&Gateway) < 4)  // check we have a valid string from VB
		*pVal = A2BSTR("");
	else
		*pVal = Gateway;
	return S_OK;
}

STDMETHODIMP CH323::put_Gateway(BSTR newVal)
{
	// TODO: Add your implementation code here
	if (SType(&newVal) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("Gateway string is empty or NULL"));
	else
		Gateway = newVal;
	return S_OK;
}

STDMETHODIMP CH323::get_UseGateway(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here
	*pVal = bUseGateway;
	return S_OK;
}

STDMETHODIMP CH323::put_UseGateway(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here
	bUseGateway = newVal;
	return S_OK;
}

STDMETHODIMP CH323::get_UseGateKeeper(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here
	*pVal = bUseGateKeeper;
	return S_OK;
}

STDMETHODIMP CH323::put_UseGateKeeper(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here
	bUseGateKeeper = newVal;
	return S_OK;
}

STDMETHODIMP CH323::get_RemoteUserName(BSTR *pVal)
{
	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CH323::Connect()
{
	// TODO: Add your implementation code here
	if (SType(&Destination) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("Destination string is empty or NULL"));
	else 
	{
		if (bUseGateway)
		{
			if (SType(&Gateway) < 4)  // check we have a valid string from VB
				Fire_Error(errFailInvalidString,OLESTR("Gateway string is empty or NULL"));
			else
			{
				endpoint->MakeOutgoingCall(BSTR(Destination),BSTR(Gateway));
			}
		}
		else
		{
			endpoint->MakeOutgoingCall(BSTR(Destination),"");
		}
	}
	return S_OK;
}

STDMETHODIMP CH323::Listen()
{
	// TODO: Add your implementation code here
	endpoint->ListenForIncomingCalls();
	return S_OK;
}

STDMETHODIMP CH323::Hangup()
{
	// TODO: Add your implementation code here
	endpoint->Hangup();
	return S_OK;
}

STDMETHODIMP CH323::Answer()
{
	// TODO: Add your implementation code here
	endpoint->AnswerCall(H323Connection::AnswerCallNow);
	return S_OK;
}

STDMETHODIMP CH323::DontAnswer()
{
	// TODO: Add your implementation code here
	endpoint->AnswerCall(H323Connection::AnswerCallDenied);
	return S_OK;
}

STDMETHODIMP CH323::UserInput(BSTR InputStr)
{
	// TODO: Add your implementation code here
	if (SType(&InputStr) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("User Input string is empty or NULL"));
	else
		endpoint->SendUserInput(InputStr);
	return S_OK;
}

short SType(BSTR *pbstr)
{
	if (pbstr == NULL) // pointer is null; will never happen
		return 1;

	if (*pbstr == NULL) // string (or variant) is allocated by VB 
	// with Dim statement, but not yet assigned
		return 2;

	if (*pbstr[0] == 0) // string is allocated and assigned to empty string ("")
		return 3;

	// string has a value; ANSI characters can be accessed at *pbstr
	return 4;
}


STDMETHODIMP CH323::RegisterGatekeeper()
{
	// TODO: Add your implementation code here
	if (SType(&GateKeeper) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("GateKeeper string is empty or NULL"));
	else
		endpoint->RegisterGatekeeper(BSTR(GateKeeper));
	return S_OK;
}

STDMETHODIMP CH323::get_RxCodec(long *pVal)
{
	// TODO: Add your implementation code here
	*pVal = endpoint->RxCodec;
	return S_OK;
}

STDMETHODIMP CH323::put_RxCodec(long newVal)
{
	// TODO: Add your implementation code here
//	if (SType(&newVal) < 4)  // check we have a valid string from VB
//		Fire_Error(errFailInvalidString,OLESTR("RxCodec string is empty or NULL"));
	return S_OK;
}


STDMETHODIMP CH323::get_TxCodec(long *pVal)
{
	// TODO: Add your implementation code here
	*pVal = endpoint->TxCodec;
	return S_OK;
}

STDMETHODIMP CH323::put_TxCodec(long newVal)
{
	// TODO: Add your implementation code here
	return S_OK;
}


STDMETHODIMP CH323::get_RxSound(BSTR *pVal)
{
	// TODO: Add your implementation code here
	*pVal = A2BSTR(endpoint->GetSoundChannelRecordDevice());
	return S_OK;
}

STDMETHODIMP CH323::put_RxSound(BSTR newVal)
{
	// TODO: Add your implementation code here
	if (SType(&newVal) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("TxSound device string is empty or NULL"));
	else
	{
	   if (!endpoint->SetSoundChannelRecordDevice(newVal))
		   	Fire_Error(errFailInvalidSoundDevice,OLESTR("Invalid sound device"));
	}
	return S_OK;
}

STDMETHODIMP CH323::get_TxSound(BSTR *pVal) // play
{
	// TODO: Add your implementation code here
	*pVal = A2BSTR(endpoint->GetSoundChannelPlayDevice());
	return S_OK;
}

STDMETHODIMP CH323::put_TxSound(BSTR newVal)
{
	// TODO: Add your implementation code here
	if (SType(&newVal) < 4)  // check we have a valid string from VB
		Fire_Error(errFailInvalidString,OLESTR("TxSound device string is empty or NULL"));
	else
	{
	   if (!endpoint->SetSoundChannelPlayDevice(newVal))
		   	Fire_Error(errFailInvalidSoundDevice,OLESTR("Invalid sound device"));
	}
	return S_OK;
}

STDMETHODIMP CH323::EnumSoundRx()
{
	// TODO: Add your implementation code here
PStringArray names = PSoundChannel::GetDeviceNames(PSoundChannel::Recorder);
  for (PINDEX i = 0; i < names.GetSize(); i++)
	Fire_SoundRxDevice(A2BSTR(names[i]));

  return S_OK;
}

STDMETHODIMP CH323::EnumSoundTx()
{
	// TODO: Add your implementation code here
PStringArray names = PSoundChannel::GetDeviceNames(PSoundChannel::Player);
  for (PINDEX i = 0; i < names.GetSize(); i++)
	Fire_SoundTxDevice(A2BSTR(names[i]));

  return S_OK;
}

STDMETHODIMP CH323::get_AutoAnswer(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here
	*pVal = endpoint->autoAnswer;
	return S_OK;
}

STDMETHODIMP CH323::put_AutoAnswer(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here
	endpoint->autoAnswer = newVal;
	return S_OK;
}

STDMETHODIMP CH323::get_SilenceDetection(VARIANT_BOOL *pVal)
{
	// TODO: Add your implementation code here
	*pVal = endpoint->silenceOn;
	return S_OK;
}

STDMETHODIMP CH323::put_SilenceDetection(VARIANT_BOOL newVal)
{
	// TODO: Add your implementation code here
	endpoint->silenceOn = newVal;
	return S_OK;
}
