	
// vbH323.h : Declaration of the CH323

#ifndef __VBH323_H_
#define __VBH323_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
#include "atlh323CP.h"
#include "dwarf.h"
#include "fire.h"
#include "version.h"

/////////////////////////////////////////////////////////////////////////////
// CH323
class ATL_NO_VTABLE CH323 : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<IH323, &IID_IH323, &LIBID_ATLH323Lib>,
	public CComControl<CH323>,
	public IPersistStreamInitImpl<CH323>,
	public IOleControlImpl<CH323>,
	public IOleObjectImpl<CH323>,
	public IOleInPlaceActiveObjectImpl<CH323>,
	public IViewObjectExImpl<CH323>,
	public IOleInPlaceObjectWindowlessImpl<CH323>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CH323>,
	public IPersistStorageImpl<CH323>,
	public ISpecifyPropertyPagesImpl<CH323>,
	public IQuickActivateImpl<CH323>,
	public IDataObjectImpl<CH323>,
	public IProvideClassInfo2Impl<&CLSID_H323, &DIID__IH323Events, &LIBID_ATLH323Lib>,
	public IPropertyNotifySinkCP<CH323>,
	public CComCoClass<CH323, &CLSID_H323>,
	public CProxy_IH323Events< CH323 >,
	public VBFire
{
protected:
	/* Map VBFire virtual functions to CProxy_IH323Events template functions */
	void fire_Error(SHORT Err, BSTR Error) { Fire_Error(Err,Error); };
	void fire_RemoteRinging() { Fire_RemoteRinging(); };
	void fire_Connected(BSTR RemoteUserName) { Fire_Connected(RemoteUserName); };
	void fire_Disconnected(BSTR RemoteUserName) { Fire_Disconnected(RemoteUserName); };
	void fire_RemoteUserInput(BSTR InputStr) { Fire_RemoteUserInput(InputStr); };
	void fire_ReceivedCall(BSTR RemoteUserName) { Fire_ReceivedCall(RemoteUserName); };
	BSTR a2BSTR(LPCSTR lp) { BSTR b = A2BSTR(lp); return b;};
	
	/* Where to store Properties of interface */
	BOOL bUseGateKeeper;
	BOOL bUseGateway;
	CComBSTR Gateway;
	CComBSTR GateKeeper;
	CComBSTR Destination;
	MyH323EndPoint * endpoint;
	
public:

	CH323()
	{
		/* Make our properties default */
		bUseGateKeeper = FALSE;
		bUseGateway = FALSE;
		endpoint = new MyH323EndPoint(this);
		endpoint->Initialise();

		/* Wizard generated */
		m_pUnkMarshaler = NULL;
	}

	~CH323()
	{
		delete endpoint;
	}

DECLARE_GET_CONTROLLING_UNKNOWN()
DECLARE_REGISTRY_RESOURCEID(IDR_H323)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CH323)
	COM_INTERFACE_ENTRY(IH323)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_PROP_MAP(CH323)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CH323)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
	CONNECTION_POINT_ENTRY(DIID__IH323Events)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CH323)
	CHAIN_MSG_MAP(CComControl<CH323>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, boolean& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, boolean& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, boolean& bHandled);



	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}

	void FinalRelease()
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_IH323,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IH323
public:
	STDMETHOD(get_SilenceDetection)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_SilenceDetection)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_AutoAnswer)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_AutoAnswer)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_TxSound)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_TxSound)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_RxSound)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_RxSound)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_TxCodec)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_TxCodec)(/*[in]*/ long newVal);
	STDMETHOD(get_RxCodec)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_RxCodec)(/*[in]*/ long newVal);
	STDMETHOD(RegisterGatekeeper)();
	STDMETHOD(DontAnswer)();
	STDMETHOD(UserInput)(/*[in]*/ BSTR Input);
	STDMETHOD(get_RemoteUserName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(Answer)();
	STDMETHOD(Hangup)();
	STDMETHOD(Listen)();
	STDMETHOD(Connect)();
	STDMETHOD(get_UseGateKeeper)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_UseGateKeeper)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_UseGateway)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_UseGateway)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_Gateway)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Gateway)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_GateKeeper)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_GateKeeper)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_RemoteHost)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_RemoteHost)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_UserName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_UserName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_JitterDelay)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_JitterDelay)(/*[in]*/ short newVal);
	STDMETHOD(get_FastStart)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_FastStart)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(EnumSoundRx)();
	STDMETHOD(EnumSoundTx)();


	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		char szText[1000];
		wsprintf(szText,"openH323 v%d.%d.%d",MAJOR_VERSION,MINOR_VERSION,BUILD_NUMBER);
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			szText, 
			lstrlen(szText));

		return S_OK;
	}
};

#endif //__VBH323_H_
